# Enum rustc_data_structures::graph::scc::NodeState

source ·

    enum NodeState<N, S> {
        NotVisited,
        BeingVisited {
            depth: usize,
        },
        InCycle {
            scc_index: S,
        },
        InCycleWith {
            parent: N,
        },
    }

## Variants§

§

### NotVisited

This node has not yet been visited as part of the DFS.

After SCC construction is complete, this state ought to be impossible.

§

### BeingVisited

This node is currently being walk as part of our DFS. It is on the stack at the depth `depth`.

After SCC construction is complete, this state ought to be impossible.

#### Fields

§`depth: usize`
§

### InCycle

Indicates that this node is a member of the given cycle.

#### Fields

§`scc_index: S`
§

### InCycleWith

Indicates that this node is a member of whatever cycle `parent` is a member of. This state is transient: whenever we see it, we try to overwrite it with the current state of `parent` (this is the “path compression” step of a union-find algorithm).

#### Fields

§`parent: N`

## Trait Implementations§

source§

### impl<N: Clone, S: Clone> Clone for NodeState<N, S>

source§

#### fn clone(&self) -> NodeState<N, S>

Returns a copy of the value. Read more
1.0.0 · source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
source§

### impl<N: Debug, S: Debug> Debug for NodeState<N, S>

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
source§

### impl<N: Copy, S: Copy> Copy for NodeState<N, S>

## Auto Trait Implementations§

§

### impl<N, S> DynSend for NodeState<N, S>
where S: DynSend, N: DynSend,

§

### impl<N, S> DynSync for NodeState<N, S>
where S: DynSync, N: DynSync,

§

### impl<N, S> Freeze for NodeState<N, S>
where S: Freeze, N: Freeze,

§

### impl<N, S> RefUnwindSafe for NodeState<N, S>
where S: RefUnwindSafe, N: RefUnwindSafe,

§

### impl<N, S> Send for NodeState<N, S>
where S: Send, N: Send,

§

### impl<N, S> Sync for NodeState<N, S>
where S: Sync, N: Sync,

§

### impl<N, S> Unpin for NodeState<N, S>
where S: Unpin, N: Unpin,

§

### impl<N, S> UnwindSafe for NodeState<N, S>
where S: UnwindSafe, N: UnwindSafe,

## Blanket Implementations§

source§

### impl<T> Aligned for T

source§

#### const ALIGN: Alignment = const ALIGN: Alignment = Alignment::of::<Self>();

Alignment of `Self`.
source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T> Instrument for T

source§

#### fn instrument(self, span: Span) -> Instrumented<Self>

Instruments this type with the provided `Span`, returning an `Instrumented` wrapper. Read more
source§

#### fn in_current_span(self) -> Instrumented<Self>

Instruments this type with the current `Span`, returning an `Instrumented` wrapper. Read more
source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> Pointable for T

source§

#### const ALIGN: usize = _

The alignment of pointer.
§

#### type Init = T

The type for initializers.
source§

#### unsafe fn init(init: <T as Pointable>::Init) -> usize

Initializes a with the given initializer. Read more
source§

#### unsafe fn deref<'a>(ptr: usize) -> &'a T

Dereferences the given pointer. Read more
source§

#### unsafe fn deref_mut<'a>(ptr: usize) -> &'a mut T

Mutably dereferences the given pointer. Read more
source§

#### unsafe fn drop(ptr: usize)

Drops the object pointed to by the given pointer. Read more
source§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
source§

### impl<T> WithSubscriber for T

source§

#### fn with_subscriber<S>(self, subscriber: S) -> WithDispatch<Self>
where S: Into<Dispatch>,

Attaches the provided `Subscriber` to this type, returning a `WithDispatch` wrapper. Read more
source§

#### fn with_current_subscriber(self) -> WithDispatch<Self>

Attaches the current default `Subscriber` to this type, returning a `WithDispatch` wrapper. Read more
source§

### impl<'a, T> Captures<'a> for T
where T: ?Sized,

## Layout§

Note: Unable to compute type layout, possibly due to this type having generic parameters. Layout can only be computed for concrete, fully-instantiated types.